﻿

Public Class SWM2
    Private Panelset(9) As Panel
    Private Responseset(36) As Panel
    Public WMAufgabenset(17) As String
    Private Rotateinfo() As Integer = {1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1}
    Private current_task As Integer = 0

    Private Uebung As Boolean
    Private Jetzt As Date
    Private Const responsetime As Integer = 60000
    Private SWMstartzeit As String
    Private Points As Integer = 0


    'center
    Function center(ByVal cont As Control, ByVal frm As Control) As Point
        Dim diff As Size = frm.Size - cont.Size
        center = New Point(CInt(diff.Width / 2), CInt(diff.Height / 2))
    End Function



    'On LoAD
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Panelset = New Panel() {PanelA01, PanelA02, PanelA03, PanelA04, PanelA05, PanelA06, PanelA07, PanelA08, PanelA09}

        WMAufgabenset(0) = "111000000"
        WMAufgabenset(1) = "001011001"
        WMAufgabenset(2) = "000011000 100100100"
        WMAufgabenset(3) = "011000000 001001001"
        WMAufgabenset(4) = "110100000"
        WMAufgabenset(5) = "000001110"
        WMAufgabenset(6) = "000101010"
        WMAufgabenset(7) = "111000000 001010000"
        WMAufgabenset(8) = "001001001 110100000"
        WMAufgabenset(9) = "010011010 000100110"
        WMAufgabenset(10) = "000001011 001001001"
        WMAufgabenset(11) = "000100110 000010111 100100100"
        WMAufgabenset(12) = "111000000 011001000 000000011"
        WMAufgabenset(13) = "001001001 100010000 100110100"
        WMAufgabenset(14) = "011000000 000001011 010100000"
        WMAufgabenset(15) = "001001001 011100000 000100100 110100000"
        WMAufgabenset(16) = "000001011 100100000 000000111 010001000"

        GroupBoxStart.Location = center(GroupBoxStart, Me)
        GroupBoxAufgabe.Location = center(GroupBoxAufgabe, Me)
        PictureBox1.Location = center(PictureBox1, Me)
        lblAchtung.Location = center(lblAchtung, Me)
        AntwortBox1.Location = center(AntwortBox1, Me)
        AntwortBox2.Location = center(AntwortBox2, Me)
        AntwortBox3.Location = center(AntwortBox3, Me)
        AntwortBox4.Location = center(AntwortBox4, Me)

        AntwortBox1.Hide()
        AntwortBox2.Hide()
        AntwortBox3.Hide()
        AntwortBox4.Hide()
        GroupBoxAufgabe.Hide()
        PictureBox1.Hide()
        lblAchtung.Hide()
        GroupBoxStart.Show()
        cmdStart.Visible = False
    End Sub


    'size-changing
    Private Sub size_changed() Handles Me.SizeChanged
        GroupBoxStart.Location = center(GroupBoxStart, Me)
        GroupBoxAufgabe.Location = center(GroupBoxAufgabe, Me)
        PictureBox1.Location = center(PictureBox1, Me)
        lblAchtung.Location = center(lblAchtung, Me)
        AntwortBox1.Location = center(AntwortBox1, Me)
        AntwortBox2.Location = center(AntwortBox2, Me)
        AntwortBox3.Location = center(AntwortBox3, Me)
        AntwortBox4.Location = center(AntwortBox4, Me)
    End Sub


    'Stellt die Aufgaben Grafisch dar, input ist ein String aus 1er und 0er mit Leerzeichen dazwischen. rotateinfo ist 1 oder 2 für links oder rechts.
    Sub Aufgabe_Auswerten(ByVal input As String, ByVal rotateinfo As Integer)

        Dim panelcount As Integer = 0

        If rotateinfo = 1 Then
            PictureBox1.Image = My.Resources.rotate_left_2
        ElseIf rotateinfo = 2 Then
            PictureBox1.Image = My.Resources.rotate_right_2
        End If
        GroupBoxAufgabe.Hide()
        PictureBox1.Show() 'erstmal rotierrichtung für 3 Sekunden anzeigen
        Application.DoEvents()
        Threading.Thread.Sleep(3000)
        PictureBox1.Hide()

        For i = 0 To 40  '40 = die maximale Länge des Input-Strings
            If i > input.Length - 1 Then  'Aufgabe anzeigen, wenn Input-String am Ende
                panelcount = 0
                lblAufgabe.Text = (i \ 9).ToString
                GroupBoxAufgabe.Show()
                Application.DoEvents()
                Threading.Thread.Sleep(4000)
                Exit For
            ElseIf input.Chars(i) = " " Then  'Aufgabe anzeigen, wenn Lücke im Input-String
                panelcount = 0
                lblAufgabe.Text = (i \ 9).ToString
                GroupBoxAufgabe.Show()
                Application.DoEvents()
                Threading.Thread.Sleep(4000)
            ElseIf input.Chars(i) = "1" Then   'Schwarz
                Panelset(panelcount).BackColor = Color.Black
                'DirectCast(Panelset(panelcount), Panel).BackColor = Color.Black
                panelcount += 1
            ElseIf input.Chars(i) = "0" Then   'Weiss
                Panelset(panelcount).BackColor = Color.White
                'DirectCast(Panelset(panelcount), Panel).BackColor = Color.White
                panelcount += 1
            End If
        Next
    End Sub


    'Rotiert je nach Argument
    Function rotate(ByVal foo As String, ByVal direction As Integer) As String 'string maximal länge 9; direction 1 für links, 2 für rechts
        rotate = foo
        If direction = 1 Then 'rotate left
            rotate = foo.Chars(2) & foo.Chars(5) & foo.Chars(8) & foo.Chars(1) & foo.Chars(4) & foo.Chars(7) & foo.Chars(0) & foo.Chars(3) & foo.Chars(6)
        ElseIf direction = 2 Then 'rotate right
            rotate = foo.Chars(6) & foo.Chars(3) & foo.Chars(0) & foo.Chars(7) & foo.Chars(4) & foo.Chars(1) & foo.Chars(8) & foo.Chars(5) & foo.Chars(2)
        End If

    End Function


    'Task Controlling Machine
    Sub Aufgabenmaschiene(Optional ByVal Again As Boolean = False)

        '1.) Achtung!
        Application.DoEvents()
        System.Threading.Thread.Sleep(250)
        lblAchtung.Show()
        Application.DoEvents()
        System.Threading.Thread.Sleep(500)
        lblAchtung.Hide()
        Application.DoEvents()
        System.Threading.Thread.Sleep(250)

        '2.) Aufgabe darstellen
        Aufgabe_Auswerten(WMAufgabenset(current_task), Rotateinfo(current_task))  'Erstmal Aufgabe darstellen

        '3.) Antwortbox darstellen

        Select Case WMAufgabenset(current_task).Length Mod 9  'zeigt die Response-Matrizen je nach Länge der aktuellen Aufgabe
            Case 0
                Responseset = New Panel() {Panel111, Panel112, Panel113, Panel114, Panel115, Panel116, Panel117, Panel118, Panel119}
                For Each i In Responseset  'resettet die Farben der Responsepanels
                    i.BackColor = Color.White
                Next
                AntwortBox1.Show()
            Case 1
                Responseset = New Panel() {Panel211, Panel212, Panel213, Panel214, Panel215, Panel216, Panel217, Panel218, Panel219, Panel221, Panel222, Panel223, Panel224, Panel225, Panel226, Panel227, Panel228, Panel229}
                For Each i In Responseset  'resettet die Farben der Responsepanels
                    i.BackColor = Color.White
                Next
                AntwortBox2.Show()
            Case 2
                Responseset = New Panel() {Panel311, Panel312, Panel313, Panel314, Panel315, Panel316, Panel317, Panel318, Panel319, Panel321, Panel322, Panel323, Panel324, Panel325, Panel326, Panel327, Panel328, Panel329, Panel331, Panel332, Panel333, Panel334, Panel335, Panel336, Panel337, Panel338, Panel339}
                For Each i In Responseset  'resettet die Farben der Responsepanels
                    i.BackColor = Color.White
                Next
                AntwortBox3.Show()
            Case 3
                Responseset = New Panel() {Panel411, Panel412, Panel413, Panel414, Panel415, Panel416, Panel417, Panel418, Panel419, Panel421, Panel422, Panel423, Panel424, Panel425, Panel426, Panel427, Panel428, Panel429, Panel431, Panel432, Panel433, Panel434, Panel435, Panel436, Panel437, Panel438, Panel439, Panel441, Panel442, Panel443, Panel444, Panel445, Panel446, Panel447, Panel448, Panel449}
                For Each i In Responseset  'resettet die Farben der Responsepanels
                    i.BackColor = Color.White
                Next
                AntwortBox4.Show()
        End Select

        'TIMER restriction
        Jetzt = DateTime.Now
        ProgressBar1.Value = 0
        ProgressBar2.Value = 0
        ProgressBar3.Value = 0
        ProgressBar4.Value = 0
        If current_task > 3 Then
            TimerRestriction.Start()
        End If

        cmdOK1.Show()
        GroupBoxAufgabe.Hide()
    End Sub


    'timer
    Private Sub TimerRestriction_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerRestriction.Tick
        Dim ZeitAbgelaufen As TimeSpan = DateTime.Now - Jetzt
        If ZeitAbgelaufen.TotalMilliseconds < responsetime Then
            ProgressBar1.Value = CInt(ZeitAbgelaufen.TotalMilliseconds * 100 / responsetime)
            ProgressBar2.Value = CInt(ZeitAbgelaufen.TotalMilliseconds * 100 / responsetime)
            ProgressBar3.Value = CInt(ZeitAbgelaufen.TotalMilliseconds * 100 / responsetime)
            ProgressBar4.Value = CInt(ZeitAbgelaufen.TotalMilliseconds * 100 / responsetime)
        Else
            cmdOK_Click(sender, e)
        End If
    End Sub


    'RESPONSE SUB
    Private Sub Panels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Panel111.Click, Panel112.Click, Panel113.Click, Panel114.Click, Panel115.Click, Panel116.Click, Panel117.Click, Panel118.Click, Panel119.Click, Panel211.Click, Panel212.Click, Panel213.Click, Panel214.Click, Panel215.Click, Panel216.Click, Panel217.Click, Panel218.Click, Panel219.Click, Panel221.Click, Panel222.Click, Panel223.Click, Panel224.Click, Panel225.Click, Panel226.Click, Panel227.Click, Panel228.Click, Panel229.Click, Panel311.Click, Panel312.Click, Panel313.Click, Panel314.Click, Panel315.Click, Panel316.Click, Panel317.Click, Panel318.Click, Panel319.Click, Panel321.Click, Panel322.Click, Panel323.Click, Panel324.Click, Panel325.Click, Panel326.Click, Panel327.Click, Panel328.Click, Panel329.Click, Panel331.Click, Panel332.Click, Panel333.Click, Panel334.Click, Panel335.Click, Panel336.Click, Panel337.Click, Panel338.Click, Panel339.Click, Panel411.Click, Panel412.Click, Panel413.Click, Panel414.Click, Panel415.Click, Panel416.Click, Panel417.Click, Panel418.Click, Panel419.Click, Panel421.Click, Panel422.Click, Panel423.Click, Panel424.Click, Panel425.Click, Panel426.Click, Panel427.Click, Panel428.Click, Panel429.Click, Panel431.Click, Panel432.Click, Panel433.Click, Panel434.Click, Panel435.Click, Panel436.Click, Panel437.Click, Panel438.Click, Panel439.Click, Panel441.Click, Panel442.Click, Panel443.Click, Panel444.Click, Panel445.Click, Panel446.Click, Panel447.Click, Panel448.Click, Panel449.Click, Panel111.DoubleClick, Panel112.DoubleClick, Panel113.DoubleClick, Panel114.DoubleClick, Panel115.DoubleClick, Panel116.DoubleClick, Panel117.DoubleClick, Panel118.DoubleClick, Panel119.DoubleClick, Panel211.DoubleClick, Panel212.DoubleClick, Panel213.DoubleClick, Panel214.DoubleClick, Panel215.DoubleClick, Panel216.DoubleClick, Panel217.DoubleClick, Panel218.DoubleClick, Panel219.DoubleClick, Panel221.DoubleClick, Panel222.DoubleClick, Panel223.DoubleClick, Panel224.DoubleClick, Panel225.DoubleClick, Panel226.DoubleClick, Panel227.DoubleClick, Panel228.DoubleClick, Panel229.DoubleClick, Panel311.DoubleClick, Panel312.DoubleClick, Panel313.DoubleClick, Panel314.DoubleClick, Panel315.DoubleClick, Panel316.DoubleClick, Panel317.DoubleClick, Panel318.DoubleClick, Panel319.DoubleClick, Panel321.DoubleClick, Panel322.DoubleClick, Panel323.DoubleClick, Panel324.DoubleClick, Panel325.DoubleClick, Panel326.DoubleClick, Panel327.DoubleClick, Panel328.DoubleClick, Panel329.DoubleClick, Panel331.DoubleClick, Panel332.DoubleClick, Panel333.DoubleClick, Panel334.DoubleClick, Panel335.DoubleClick, Panel336.DoubleClick, Panel337.DoubleClick, Panel338.DoubleClick, Panel339.DoubleClick, Panel411.DoubleClick, Panel412.DoubleClick, Panel413.DoubleClick, Panel414.DoubleClick, Panel415.DoubleClick, Panel416.DoubleClick, Panel417.DoubleClick, Panel418.DoubleClick, Panel419.DoubleClick, Panel421.DoubleClick, Panel422.DoubleClick, Panel423.DoubleClick, Panel424.DoubleClick, Panel425.DoubleClick, Panel426.DoubleClick, Panel427.DoubleClick, Panel428.DoubleClick, Panel429.DoubleClick, Panel431.DoubleClick, Panel432.DoubleClick, Panel433.DoubleClick, Panel434.DoubleClick, Panel435.DoubleClick, Panel436.DoubleClick, Panel437.DoubleClick, Panel438.DoubleClick, Panel439.DoubleClick, Panel441.DoubleClick, Panel442.DoubleClick, Panel443.DoubleClick, Panel444.DoubleClick, Panel445.DoubleClick, Panel446.DoubleClick, Panel447.DoubleClick, Panel448.DoubleClick, Panel449.DoubleClick
        Dim this As Panel
        this = DirectCast(sender, Panel)

        If this.BackColor = Color.Black Then
            this.BackColor = Color.White
        ElseIf this.BackColor = Color.White Then
            this.BackColor = Color.Black
        End If
    End Sub


    'Confirm RESPONSE
    Private Sub cmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOK1.Click, cmdOK2.Click, cmdOK3.Click, cmdOK4.Click


        TimerRestriction.Stop()
        ProgressBar1.Value = 0
        ProgressBar2.Value = 0
        ProgressBar3.Value = 0
        ProgressBar4.Value = 0

        'save response:
        Dim response_string As String = ""
        Dim temp As String = ""
        For i = 0 To WMAufgabenset(current_task).Length - WMAufgabenset(current_task).Length Mod 9  'Von 0 bis Aufgabenlänge OHNE Leerzeichen

            If i = WMAufgabenset(current_task).Length - WMAufgabenset(current_task).Length Mod 9 Then 'Wenn quasi alle Panels schon durch sind und eigentlich IndexError wäre
                temp = rotate(temp, 3 - Rotateinfo(current_task)) 'dreht zurück, weil 3-1=2 und 3-2=1
                response_string &= temp
                temp = ""
            ElseIf Responseset(i).BackColor = Color.Black Then
                If i > 0 And i Mod 9 = 0 Then
                    temp = rotate(temp, 3 - Rotateinfo(current_task)) 'dreht zurück, weil 3-1=2 und 3-2=1
                    response_string &= temp
                    temp = ""
                    response_string &= " "
                End If
                temp &= "1"
            ElseIf Responseset(i).BackColor = Color.White Then
                If i > 0 And i Mod 9 = 0 Then
                    temp = rotate(temp, 3 - Rotateinfo(current_task)) 'dreht zurück, weil 3-1=2 und 3-2=1
                    response_string &= temp
                    temp = ""
                    response_string &= " "
                End If
                temp &= "0"
            End If
        Next

        'Abgleich von Response und Vorlage: geht alle 10 Panels die jeweils 9 nächsten Panels durch.
        Dim temp_current_item As Integer = 0
        For i = 0 To WMAufgabenset(current_task).Length - 9 Step 10

            temp_current_item += 1

            If response_string.Substring(i, 9) = WMAufgabenset(current_task).Substring(i, 9) Then
                Points += 1
                'Uebersicht.dSavings.Rows.Item(Uebersicht.dSavings.Rows.Count - 1).Item(Uebersicht.dSavings.Columns.IndexOf("SWMr" & CStr(current_task) & "-" & CStr(temp_current_item))) = 1
            Else
                'Uebersicht.dSavings.Rows.Item(Uebersicht.dSavings.Rows.Count - 1).Item(Uebersicht.dSavings.Columns.IndexOf("SWMr" & CStr(current_task) & "-" & CStr(temp_current_item))) = 0
            End If

        Next

        'display feedback (the correct responses)
        flpFeedback1.Controls.Clear()
        Dim arrCorrect As String() = WMAufgabenset(current_task).Split(CChar(" "))

        For Each s As String In arrCorrect
            s = rotate(s, Rotateinfo(current_task))
            Dim this As New wclpanelSWM.SwmPanel
            Dim indexinput As Integer = 0
            Dim blArray As Boolean(,)
            ReDim blArray(2, 2)
            For i = 0 To blArray.GetUpperBound(0)
                For j = 0 To blArray.GetUpperBound(1)
                    If s(indexinput) = "1" Then
                        blArray(i, j) = True
                    ElseIf s(indexinput) = "0" Then
                        blArray(i, j) = False
                    End If
                    indexinput += 1
                Next
            Next
            this.SetValues(blArray)
            flpFeedback1.Controls.Add(this)
        Next

        'display feedback (the responses given)
        flpFeedback2.Controls.Clear()
        Dim arrResponses As String() = response_string.Split(CChar(" "))

        For Each s As String In arrResponses
            s = rotate(s, Rotateinfo(current_task))
            Dim this As New wclpanelSWM.SwmPanel
            Dim indexinput As Integer = 0
            Dim blArray As Boolean(,)
            ReDim blArray(2, 2)
            For i = 0 To blArray.GetUpperBound(0)
                For j = 0 To blArray.GetUpperBound(1)
                    If s(indexinput) = "1" Then
                        blArray(i, j) = True
                    ElseIf s(indexinput) = "0" Then
                        blArray(i, j) = False
                    End If
                    indexinput += 1
                Next
            Next
            this.SetValues(blArray)
            flpFeedback2.Controls.Add(this)
        Next

        'show tlpFeedback
        AntwortBox1.Hide()
        AntwortBox2.Hide()
        AntwortBox3.Hide()
        AntwortBox4.Hide()
        tlpFeedback.Location = center(tlpFeedback, Me)
        tlpFeedback.Show()
    End Sub


    'confirm feedack
    Private Sub btnFeedbackOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFeedbackOK.Click

        tlpFeedback.Hide()

        'checkt ob der aktuelle Abschnitt zu Ende ist.
        current_task += 1
        If (Uebung And current_task < 4) Or (Not Uebung And current_task < WMAufgabenset.GetUpperBound(0)) Then 'weiter machen
            Aufgabenmaschiene()
        Else 'aufhören...
            If current_task > 4 Then  '...aber nur nach der Aufgabenphase
                Me.Close()
            Else  'sonst geht's zurück zum Start
                cmdStart.Visible = True
                GroupBoxStart.Show()
            End If
        End If
    End Sub



    'START
    Private Sub cmdStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStart.Click
        SWMstartzeit = DateTime.Now.ToString
        Uebung = False
        current_task = 4
        GroupBoxStart.Hide()
        Application.DoEvents()
        Aufgabenmaschiene(False)
    End Sub


    'UEBUNG
    Private Sub cmdUebung_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdUebung.Click
        Uebung = True
        current_task = 0
        cmdUebung.Visible = False
        GroupBoxStart.Hide()
        Application.DoEvents()
        Aufgabenmaschiene(True)
    End Sub

End Class